from __future__ import absolute_import, unicode_literals
import os
import django
from celery import Celery

# set the default Django settings module for the 'celery' program.
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'caromserver.settings')

app = Celery('caromserver')

# Using a string here means the worker don't have to serialize
# the configuration object to child processes.
# - namespace='CELERY' means all celery-related configuration keys
#   should have a `CELERY_` prefix.
app.config_from_object('django.conf:settings')

# Load task modules from all registered Django app configs.

os.environ.setdefault("DJANGO_SETTINGS_MODULE", "caromserver.settings")
django.setup()

app.autodiscover_tasks(['billard'])


@app.task(bind=True)
def debug_task(self):
    print('Request: {0!r}'.format(self.request))